#!/usr/bin/python2.6

from string import split,  lower,  upper,  replace,  strip, find

from Numeric import zeros

from os import system
    
from genesilico.structure.BrutePDBParser import BrutePDBParser

#DIR = '../atom_files/'
#REFINER_DIR = '../refiner/ss/'
#REFINER_DDIR = '../refiner/dist/'

#SS_PRED_DIR = '../../server/'
#PATH = '../RR/BEST/MULTICOM/'

DIR = '/home/michalp/gd_server/atom_files/'
REFINER_DIR = '/home/michalp/gd_server/refiner/ss/'
REFINER_DDIR = '/home/michalp/gd_server/refiner/dist/'

SS_PRED_DIR = '/home/michalp/server/'
PATH = '/home/michalp/gd_server/RR/BEST/MULTICOM/'

FACTORING = '/home/michalp/gd_server/gd2a.txt'

from modeller import *
from modeller.automodel import * # Load the automodel class

#__METRIC__ = 'CA'
__METRIC__ = None
__SHEET__ = True

def make_matrix(N, cm, mapping, separation, symmetric=True):
    """This function two-dimensional matrix out of contact pair list."""
    
    #TYPE = 
    
    matrix=zeros((N, N))#, TYPE)
    
    if mapping != None:
        M = len(mapping)
    else:
        M = N
    
    val_list=[]
    
    for (x, y) in cm:
        if abs(x-y) >= separation:
            val = cm[(x, y)]
            if val != 0:
                if val < 0:
                    print x,  y,  val
                    raise
                if mapping != None:
                    X = mapping[x]
                    Y = mapping[y]
                (X,Y) = (min(X,Y),max(X,Y))
                matrix[X][Y] = val
                if symmetric:
                    matrix[Y][X] = val
    
    #!! no diaginal    
    return matrix
    
def make_resnames(seqres):
    
    s = ''
    for r in seqres:
        s = s + r[7:-1]
    
    N = len(s)
    
    resnames = {}
    for i in range(N):
        resnames[i] = (s[i], '?',  1.0,  999.99)

    list = (None,  None)
    map = (range(N),  range(N))
    
    return resnames,  N,  list,  map

def trim_eerest(EEREST,  SS):
    
    ETOPOLOGY = []
    I = None
    for i in range(len(SS)):
        if SS[i] =='S' and I == None:
            I = i
        elif SS[i] != 'S' and I != None:# and i > I + 1:
            ETOPOLOGY.append(range(I, i))
            I = None
        if i == len(SS) -1 and I != None:# and i > I + 1:
            ETOPOLOGY.append(range(I, len(SS)))
    
    N = len(ETOPOLOGY)
    if N == 0:
        return EEREST,  []
    
    CONTACT = zeros((N, N))
    CONTACT2 = zeros((N, N))
    
    for i in range(N):
        for j in range(i+1, N):
            
            range1 = ETOPOLOGY[i]
            range2 = ETOPOLOGY[j]
            
            CNT1 = 0
            CNT2 = 0
            for k in range1:
                OLD_CNT1 = CNT1
                OLD_CNT2 = CNT2
                for l in range2:
                    k, l = min(k, l),  max(k, l)
                    for (A, B, D) in EEREST:
                        A,  B = min(A, B),  max(A, B)
                        if A == k and B == l:#too restrictive
                            if D == 1:
                                CNT1 = CNT1 + 1
                                break
                            elif D == 2:
                                CNT2 = CNT2 + 1
                    
                    if CNT1 > OLD_CNT1:# single residue vs single residue exit term: diff cnt
                        break
                
                if CNT1 >= 3:# single residue vs another strand exit term: global cnt
                    break
            
            if CNT1 >= 3 or (CNT1 >= 2 and CNT2 >= 5):
                CONTACT[i][j] = 1
                CONTACT[j][i] = 1
                #print i+1,  j+1,  "S",  CNT1,  CNT2,  (CNT1+0.0)/min(len(range1), len(range2)),  (CNT2+0.0)/min(len(range1), len(range2))
            elif CNT1 > 0:
                #print i,  j,  "0",  CNT1,  CNT2,  (CNT1+0.0)/min(len(range1), len(range2)),  (CNT2+0.0)/min(len(range1), len(range2))
                pass
    
    EXTRA = []
    
    for i in range(N):
        SC = sum(CONTACT[i]) 
        if SC not in [1, 2]:
            print "extraordinary beta topology detected",  str(i+1),  SC, 
            if SC != 3:
                EXTRA.append(i)
                print
            else:
                TOP_L = {}
                for j in range(N):
                    if i != j and CONTACT[i][j] == 1:
                        TOP_L[j] = len(ETOPOLOGY[j])
                for k in TOP_L.keys():
                    if TOP_L[k] == min(TOP_L.values()):
                        CONTACT[i][k] = 0
                        CONTACT[k][i] = 0
                        break
                print "...fixed"
    
    TEMP_EEREST = []
    
    for i in range(N):
        STYPE = sum(CONTACT[i])
        if STYPE not in [1, 2]:
            continue
        for j in range(i+1, N):
            
            if CONTACT[i][j]:
                
                L1 = len(ETOPOLOGY[i])
                L2 = len(ETOPOLOGY[j])
                
                SHEET = zeros((L1, L2))
                
                for (A, B, D) in EEREST:
                    if A in ETOPOLOGY[i] and B in ETOPOLOGY[j]:
                        I = ETOPOLOGY[i].index(A)
                        J = ETOPOLOGY[j].index(B)
                        if D == 1:
                            SHEET[I][J] = 1
                
                LS = min(L1, L2)
                LD = abs(L2-L1)
                NEW_SHEET = zeros((L1, L2))
                FOUND = False
                
                FOUND_REC = []
                for K in range(LD+1):
                    FOUNDp = True
                    FOUNDap = True
                    C = 0
                    for I in range(LS):
                        if L1 <= L2:
                            I2 = I
                            J2 = I+K
                            I3 = I
                            J3 = LS+LD-K-I-1
                            
                        else:
                            I2 = I+K
                            J2 = I
                            I3 = LS+LD-K-I-1
                            J3 = I
                        
                        if SHEET[I2][J2] != 1:
                            if FOUNDp == True:
                                FOUNDp = None
                            elif FOUNDp == None:
                                FOUNDp = -1
                            elif FOUNDp == -1:
                                FOUNDp = False
                            
                        if SHEET[I3][J3] != 1:
                            if FOUNDap == True:
                                FOUNDap = None
                            elif FOUNDap == None :
                                FOUNDap = -1
                            elif FOUNDap == -1:
                                FOUNDap = False
                            
                        C = C + 1
                        if (FOUNDp == -1 and LS == 3) or (FOUNDp == None and LS == 2):
                            FOUNDp = False
                        if (FOUNDap == -1 and LS == 3) or (FOUNDap == None and LS == 2):
                            FOUNDap = False
                        
                        if (FOUNDp == False and FOUNDap == False):
                            break
                    
                    FOUND_REC.append((FOUNDp,  FOUNDap,  K))
                
                Fp = [0, 0, 0]
                Fap = [0, 0, 0]
                for (FOUNDp,  FOUNDap,  K) in FOUND_REC:
                    if FOUNDp == True:
                        Fp[0] = Fp[0] + 1
                    elif FOUNDp == None:
                        Fp[1] = Fp[1] + 1
                    elif FOUNDp == -1:
                        Fp[2] = Fp[2] + 1
                    if FOUNDap == True:
                        Fap[0] = Fap[0] + 1
                    elif FOUNDap == None:
                        Fap[1] = Fap[1] + 1
                    elif FOUNDap == -1:
                        Fap[2] = Fap[2] + 1
                
                if Fp[0] > Fap[0] or (Fp[0] == Fap[0] and Fp[1] > Fap[1]) or (Fp[0] == Fap[0] and Fp[1] == Fap[1] and Fp[2] > Fap[2]):
                    FP = True
                elif Fap[0] > Fp[0] or (Fap[0] == Fp[0] and Fap[1] > Fp[1]) or (Fap[0] == Fp[0] and Fap[1] == Fp[1] and Fap[2] > Fp[2]):
                    FP = False
                else:
                    FP = None
                
                for (FOUNDp,  FOUNDap,  K) in FOUND_REC:
                    if FP in [True, None]:
                        FOUNDap = False
                    if FP in [False, None]:
                        FOUNDp = False
                    
                    if (FOUNDp in [True, None, -1] or FOUNDap in [True, None, -1]):
                        
                        OLD_I2 = None
                        OLD_J2 = None
                        
                        for I in range(LS):
                            if L1 <= L2:
                                if FOUNDp in [True, None,  -1]:
                                    I2 = I
                                    J2 = I+K
                                else:
                                    I2 = I
                                    J2 = LS+LD-K-I-1
                            else:
                                if FOUNDp in [True, None,  -1]:
                                    I2 = I+K
                                    J2 = I
                                else:
                                    I2 = LS+LD-K-I-1
                                    J2 = I
                            
                            if (OLD_I2 == None or abs(I2-OLD_I2) == 1) and (OLD_J2 == None or abs(J2 - OLD_J2) == 1):
                                NEW_SHEET[I2][J2] = 1
                                
                                OLD_I2 = I2
                                OLD_J2 = J2
                        
                        FOUND = True
                
                FP2 = None
                if not FOUND:
                    
                    FOUNDpu = True
                    FOUNDapu = True
                    FOUNDpd = True
                    FOUNDapd = True
                    C = 0
                    
                    for I in range(LS-1):
                        if L1 <= L2:
                            I2 = I + 1
                            J2 = I
                            I3 = I
                            J3 = I + LD + 1
                            
                            I4 = I
                            J4 = LS - 1 - I - 1
                            I5 = I + 1
                            J5 = LS - 1 - I + LD
                        else:
                            I2 = I
                            J2 = I + 1
                            I3 = I + LD + 1
                            J3 = I
                            
                            I4 = LS - 1 - I - 1
                            J4 = I
                            I5 = LS - 1 - I + LD
                            J5 = I + 1
                            
                        if SHEET[I2][J2] != 1:
                            if FOUNDpu == True:
                                FOUNDpu = None
                            elif FOUNDpu == None:
                                FOUNDpu = -1
                            elif FOUNDpu == -1:
                                FOUNDpu = False
                        
                        if SHEET[I3][J3] != 1:
                            if FOUNDpd == True:
                                FOUNDpd = None
                            elif FOUNDpd == None :
                                FOUNDpd = -1
                            elif FOUNDpd == -1:
                                FOUNDpd = False
                        
                        if SHEET[I4][J4] != 1:
                            if FOUNDapu == True:
                                FOUNDapu = None
                            elif FOUNDapu == None:
                                FOUNDapu = -1
                            elif FOUNDapu == -1:
                                FOUNDapu = False
                                
                        if SHEET[I5][J5] != 1:
                            if FOUNDapd == True:
                                FOUNDapd = None
                            elif FOUNDapd == None :
                                FOUNDapd = -1
                            elif FOUNDapd == -1:
                                FOUNDapd = False
                        
                        C = C + 1
                        
                        if (FOUNDpu == -1 and LS == 3) or (FOUNDpu == None and LS == 2):
                            FOUNDpu = False
                        if (FOUNDapu == -1 and LS == 3) or (FOUNDapu == None and LS == 2):
                            FOUNDapu = False
                        if (FOUNDpd == -1 and LS == 3) or (FOUNDpd == None and LS == 2):
                            FOUNDpd = False
                        if (FOUNDapd == -1 and LS == 3) or (FOUNDapd == None and LS == 2):
                            FOUNDapd = False
                    
                    if (FOUNDpu in [True, None, -1] or FOUNDapu in [True, None, -1] or FOUNDpd in [True, None, -1] or FOUNDapd in [True, None, -1]):
                        if ((FOUNDpu == True or FOUNDpd == True) and (FOUNDapu != True and FOUNDapd != True)) or ((FOUNDpu == None or FOUNDpd == None ) and (FOUNDapu not in [True,  None] and FOUNDapd not in [True,  None])) or ((FOUNDpu == -1 or  FOUNDpd == -1) and (FOUNDapu == False and FOUNDapd == False)):
                            FP2 = True
                        elif ((FOUNDapu == True or FOUNDapd == True) and (FOUNDpu != True and FOUNDpd != True)) or ((FOUNDapu == None or FOUNDapd == None ) and (FOUNDpu not in [True,  None] and FOUNDpd not in [True,  None])) or ((FOUNDapu == -1 or  FOUNDapd == -1) and (FOUNDpu == False and FOUNDpd == False)):
                            FP2 = False
                        
                        if FP2 != None:
                            for I in range(LS-1):
                                if FP2:
                                    if (FOUNDpu == True and FOUNDpd != True) or (FOUNDpu == None and FOUNDpd not in [True,  None]) or (FOUNDpu == -1 and FOUNDpd == False):
                                        if L1 <= L2:
                                            I2 = I + 1
                                            J2 = I
                                        else:
                                            I2 = I
                                            J2 = I + 1
                                    else:
                                        if L1 <= L2:
                                            I2 = I
                                            J2 = I + LD + 1
                                        else:
                                            I2 = I + LD + 1
                                            J2 = I  
                                else:
                                    if (FOUNDapu == True and FOUNDapd != True) or (FOUNDapu == None and FOUNDapd not in [True,  None]) or (FOUNDapu == -1 and FOUNDapd == False):
                                        if L1 <= L2:
                                            I2 = I
                                            J2 = LS - 1 - I - 1
                                        else:
                                            I2 = LS - 1 - I - 1
                                            J2 = I
                                    else:
                                        if L1 <= L2:
                                            I2 = I + 1
                                            J2 = LS - 1 - I + LD
                                        else:
                                            I2 = LS - 1 - I + LD
                                            J2 = I + 1  
                                
                                NEW_SHEET[I2][J2] = 1
                                
                            FOUND = True
                    
                if FOUND:
                    
                    if FP2 == True or FP2 == False:
                        print "extra", 
                    if FP == True or FP2 == True:
                        print "parralel sheet found", 
                    else:
                        print "antiparralel sheet found", 
                    
                    CONTACT2[i][j] = 1
                    CONTACT2[j][i] = 1
                    
                    for k in range(L1):
                        for l in range(L2):
                            
                            if NEW_SHEET[k][l] == 1:
                                
                                A = ETOPOLOGY[i][k]
                                B = ETOPOLOGY[j][l]
                                if STYPE == 1:
                                    D = -1
                                elif STYPE == 2:
                                    D = -2
                                
                                A,  B = min(A, B),  max(A, B)
                                
                                TEMP_EEREST.append((A, B, D, STYPE))
                                
                else:
                    print "no beta sheet extracted", 
                print i+1,  j+1
    
    for i in range(N):
        if i not in EXTRA:
            PAIRED = False
            for j in range(N):
                if CONTACT[i][j] == 1:
                    if CONTACT2[i][j] == 1:
                        PAIRED = True
                        break
            if not PAIRED:
                print "extraordinary unpaired beta strand detected",  str(i+1)
                EXTRA.append(i)
    
    ETOP = []
    for I in EXTRA:
        TOP = ETOPOLOGY[I]
        ETOP.append(TOP)
    
    for (X, Y, D2) in EEREST:
        if D2 == 1:
            for (A, B, D,  ST) in TEMP_EEREST:
                if ST != 1 and (A,  B) != (X,  Y):
                    if abs(X-A) <= 2 and abs(Y-B) <= 2:#non-hydrogen close beta contact
                        ###TEMP_EEREST.append((X, Y, D2,None))
                        ###break
                        pass
        
        elif D2 == 2:
            for (A, B, D,  ST) in TEMP_EEREST:
                if ST != 1 and (A,  B) != (X,  Y):
                    if abs(X-A) <= 2 and abs(Y-B) <= 2:#non-hydrogen close beta medium contact
                        TEMP_EEREST.append((X, Y, D2,None))
                        break
                        
    
    NEW_EEREST = []
    for (i, j, d, t) in TEMP_EEREST:
        NEW_EEREST.append((i, j, d))
    
    print "BETA contacts cropped:",  str(len(EEREST)),  ">>>",  str(len(NEW_EEREST))
    
    return NEW_EEREST,  ETOP

def read_contacts(cm_file,  ss=None):
    
    D_CUTOFF_REFINER = 3 
    cm,  seq,  r,  o,  t = parse_casp(open(cm_file).readlines())
    
    resnames,  N,  list,  map = make_resnames(seq)
    M = None
    for c in cm.keys():
        M = max(M, max(c))
    M = M + 1
    N = M
    
    atoms_map,  residua_map = map
    
    cm2 = make_matrix(N, cm, atoms_map, 0)
    
    DIST = []
    STD = []
    f = open(FACTORING, 'r')
    row = f.readline()
    j = 0
    while j <= D_CUTOFF_REFINER:
        i,  Dreal,  StDev = split(row, ',')
        Dreal = float(Dreal)
        StDev = float(StDev)
        DIST.append(Dreal)
        STD.append(StDev)
        row = f.readline()
        j = j + 1
    f.close()
    
    EEREST = []
    
    restr=[]
    for i in range(N):
        for j in range(i+1, N):
            d = cm2[i][j]
            if d > 0 and abs(j-i) >= 4 and d <= D_CUTOFF_REFINER:
                if ss[i] == 'S' or ss[j] == 'S':
                    if ss[i] == 'S' and ss[j] == 'S':#intra beta
                        EEREST.append((i, j, d))
                    elif d == 1 and ((ss[i] == 'S' and ss[j] != 'S' and ((j > 0 and ss[j-1] == 'S') or (j < N-1 and ss[j+1] == 'S'))) or (ss[j] == 'S' and ss[i] != 'S' and ((i > 0 and ss[i-1] == 'S') or (i < N-1 and ss[i+1] == 'S')))):
                        #beta-end vs beta-tail contact
                        ###D = 6.54
                        ###D = 6.59
                        ###D = 6.57
                        ###STDEV = 1.0*0.96
                        D = 5.97686
                        STDEV = 1.5*0.94402
                        
                        line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.5'
                        restr.append(line+'\n')
                    elif d == 1:#beta vs non-beta contact
                        #D = DIST[d]
                        #STDEV = STD[d]
                        ###D = 6.54
                        ###D = 6.59
                        ###D = 6.57
                        ###STDEV = 1.0*0.96
                        if ss[i] == 'H' or ss[j] == 'H':
                            D = 6.86291
                            STDEV = 1.5*0.87823
                        else:###if ss[i] not in 'SH' or ss[j] not in 'SH':
                            D = 6.47548
                            STDEV = 1.5*0.96044
                        
                        line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.5'
                        restr.append(line+'\n')
                    elif d == 2:#beta vs non-beta medium contact
                        D = DIST[d]
                        STDEV = 1.5*STD[d]
                        
                        ###line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.25'
                        ###restr.append(line+'\n')
                elif d == 2 and ss[i] != 'S' and ss[j] != 'S' and (((j > 0 and ss[j-1] == 'S') or (j < N-1 and ss[j+1] == 'S')) or ((i > 0 and ss[i-1] == 'S') or (i < N-1 and ss[i+1] == 'S'))):
                        #medium contact of a beta tail
                        D = DIST[d]
                        STDEV = 1.5*STD[d]
                        
                        line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.25'
                        restr.append(line+'\n')
                else:
                    if d == 1:#helix/coil contact
                        ###D = 6.54
                        ###STDEV = 1.0*0.91
                        ###D = 6.28
                        ###D = 6.57
                        ###STDEV = 1.0*0.96
                        if ss[i] == 'H' and ss[j] == 'H':
                            D = 6.06732
                            STDEV = 1.5*0.90023
			elif ss[i] == '-' and ss[j] == '-':
			    D = 6.38047
			    STDEV = 1.5*1.05972
                        else:###if ss[i] not in 'SH' and ss[j] not in 'SH':
                            D = 6.59954###6.38047
                            STDEV = 1.5*0.98310###1.5*1.05972
                        
                        line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.5'
                        restr.append(line+'\n')
                    elif d == 2:#helix/coil medium contact
                        D = DIST[d]
                        STDEV = 1.5*STD[d]
                        
                        line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.25'
                        restr.append(line+'\n')
                    else:#helix/coil far contact
                        D = DIST[d]
                        STDEV = 1.5*STD[d]
                        
                        line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.17'
                        restr.append(line+'\n')
    
    NEW_EEREST,  EETOP = trim_eerest(EEREST,  ss)
    
    for TOP in EETOP:
        for i in range(N):
            for j in range(i+1, N):
                if (i in TOP or j in TOP) and abs(i-j) >= 4:
                    d = cm2[i][j]
                    if d == 1 and ss[i] == 'S' and ss[j] == 'S':#unpaired strand beta contacts
                        ###D = 5.48
                        ###D = 5.96
                        D = 5.97686
                        STDEV = 1.5*0.94402
                        
                        line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.75'
                        restr.append(line+'\n')
                    elif d == 1 and (ss[i] == 'S' or ss[j] == 'S'):#unpaired strand contacts
                        ###D = 6.54
                        ###D = 6.59
                        ###D = 6.58
                        ###STDEV = 1.0*0.96
                        if (ss[i] == 'S' and ss[j] == 'H') or (ss[i] == 'H' and ss[j] == 'S'):
                            D = 6.86291
                            STDEV = 1.5*0.87823
                        else:
                            D = 6.47548
                            STDEV = 1.5*0.96044
                        
                        line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.5'
                        restr.append(line+'\n')
                    elif d == 2 and (ss[i] == 'S' or ss[j] == 'S'):#unpaired strand medium contact
                        D = DIST[d]
                        STDEV = 1.5*STD[d]
                        
                        ###line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.25'
                        ###restr.append(line+'\n')
    
    for (i, j, d) in NEW_EEREST:
        if d == -1 or d == -2:#hydrogen beta contacts
            ###D = 5.48
            ###STDEV = 1.0*0.46
            ###D = 5.97686
            ###STDEV = 1.5*0.94402/3
            ##########
            D = 5.00
            STDEV = 0.5###1.5*0.63
            ##########
            
            line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.75'
            restr.append(line+'\n')
        elif d == 1:#non-hydrogen beta contacts
            ###D = 5.97
            ###STDEV = 1.0*0.92
            ###D = 5.96
            ###STDEV = 1.0*0.91
            D = 5.97686
            STDEV = 1.5*0.94402
            
            line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.5'
            restr.append(line+'\n')
        else:
            D = DIST[d]
            STDEV = 1.5*STD[d]
        
            line = str(i+1)+' '+str(j+1)+' '+str(round(D, 2))+' '+str(round(STDEV, 2))+' '+'0.25'
            restr.append(line+'\n')
    
    code = cm_file[40:-21]
    
    reff=open(REFINER_DDIR+code+'.distance_restrs.dat', 'w')
    reff.writelines(restr)
    reff.close()
    
    return cm2,  resnames,  N,  (list,  map)

def read_ss(pdb_file,  chain=None):
    
    parser = BrutePDBParser()
    struct = parser.get_structure(DIR+pdb_file)
    model = struct[0]
    
    ###########################
    ###change!!
    code = pdb_file[-8:-4]
    ###########################
    SS_DICT = {'H':2, 'S':4, 'T':1, '-':1,'E':4,'C':1}
    ss_seq = []
    
    if chain == None:
        chains = model.child_list
    else:
        chains= [model[chain]]
    ss = ''
    
    shift = None
    for c in chains:
        for r in c:
            #if r.get_id()[0] == ' ':
            aa = parser.translator.get1original(r.get_resname())
            if aa != 'X':
                if shift == None:
                    shift = r.get_id()[1]-1
                SS = r.xtra['SS_PDB']
                if SS == 'T':
                    SS = '-'
                ss = ss + SS
                sscode = SS_DICT[SS]
                ss_seq.append(sscode)
    
    check = replace(ss, '-', '')
    if len(check) == 0:
        raise "no ss in pdb"
    
    reff=open(REFINER_DIR+code+'.seq.mut', 'w')
    for i in range(len(ss_seq)):
        S = ss_seq[i]
        reff.write(str(i+1)+' NOP '+str(S)+'\n')
    reff.close()
    
    #nothing for struct-based
    #if shift > 0:
    #    ss = shift*'-'+ss
    #if shift < 0:
    #    #ss = ss[-shift:]-shift*'-'
    #    ss = -shift*'-'+ss
        
    sss = 'H' in ss or 'S' in ss
    
    if not sss:
        raise 'no ss records'
    
    return ss


#################
def read_ss_pred_old(pdb_file,  chain=None, ALTER=1):


    ###########################
    ###change!!
    code = pdb_file[-8:-4]
    ###########################
    SS_DICT = {'H':2, 'S':4, 'T':1, '-':1, 'C':1,'E':4}
    ss_seq = []

    ss = ''

    shift = None
    
    ssfile = open(SS_PRED_DIR+pdb_file+'.ss','r')
    row = ssfile.readline()

    while row != '':
	ID, AA, SS, X, Y, Z = split(strip(row))
	sscode = SS_DICT[SS]
        
	if SS in 'TC':
             	SS = '-'
        elif SS == 'E':
		SS = 'S' 
	ss = ss + SS

	ss_seq.append(sscode)
	row = ssfile.readline()
    ssfile.close()

    #check = replace(ss, '-', '')
    #if len(check) == 0:
    #    raise "no ss in pdb"
	
    if ALTER != None:
	    reff=open(REFINER_DIR+pdb_file+'.seq.mut', 'w')
	    for i in range(len(ss_seq)):
	        S = ss_seq[i]
	        reff.write(str(i+1)+' NOP '+str(S)+'\n')
	    reff.close()

    #sss = 'H' in ss or 'S' in ss
    #if not sss:
    #    raise 'no ss records'

    return ss


##################
def read_ss_pred(pdb_file,  chain=None, ALTER=1):


    ###########################
    ###change!!
    #code = pdb_file[-8:-4]
    ###########################

    SSPRED_PATH = '/home/michalp/server/'
    FASDIR = '/home/michalp/server/fasta/'

    fas_file = FASDIR+pdb_file+'.fas'
    ss_file = SSPRED_PATH+pdb_file+'.sspro.ss'
    ex = system('ls '+ss_file+' 1>/dev/null 2>/dev/null')
    if ex > 0:
	#print 'Predicting ss for '+fas_file+' using sspro...' 

	sspred_cmd = '/home/michalp/3rdparty/sspro/bin/predict_ssa.sh'
	#print sspred_cmd+' '+fas_file+' '+ss_file
	#system(sspred_cmd+' '+fas_file+' '+ss_file) 

    SS_DICT = {'H':2, 'S':4, 'T':1, '-':1, 'C':1,'E':4}
    ss_seq = []

    ss = ''
    shift = None
   
    #ssfile = open(SS_PRED_DIR+pdb_file+'.ss','r')
    #row = ssfile.readline()

    ssfile = open(ss_file,'r')
    row = ssfile.readline()
    row = ssfile.readline()
    ssseq = strip(ssfile.readline())
    ssfile.close()

    #while row != '':
    for SS in ssseq:
        #ID, AA, SS, X, Y, Z = split(strip(row))
        sscode = SS_DICT[SS]

        if SS in 'TC':
                SS = '-'
        elif SS == 'E':
                SS = 'S'
        ss = ss + SS

        ss_seq.append(sscode)
        #row = ssfile.readline()
    #ssfile.close()

    #check = replace(ss, '-', '')
    #if len(check) == 0:
    #    raise "no ss in pdb"

    ###MODE fix
    #if ALTER != None:
    if ALTER == False:
	    ###
            reff=open(REFINER_DIR+pdb_file+'.seq.mut', 'w')
            for i in range(len(ss_seq)):
                S = ss_seq[i]
                reff.write(str(i+1)+' NOP '+str(S)+'\n')
            reff.close()

    #sss = 'H' in ss or 'S' in ss
    #if not sss:
    #    raise 'no ss records'

    return ss

###################

    
def parse_casp(rowdata, ftype='CASP', method=None):
    
    i = 0
    row = rowdata[i]
    
    T = None 
    
    seq = []
    remark= []
    other={'target':[], 'author':[],  'method':[]}
    contacts = {}
    
    in_map = False
    for row in rowdata:
        if row == '\n':
            continue
        if in_map == False:
            try:
                if ftype in ['casp','CASP']:
                    n = int(split(row)[0])
                elif ftype == 'eva':
                    if row[:5] != 'CONTC':
                        raise ValueError
                elif ftype == 'casp-like':
                    i, j, p = split(row)
                    i = int(i)
                    j = int(j)
                    p = float(p)
                in_map = True
            except ValueError:
                pass
        
        if in_map:
            #dict fill-in
            if row[:3] == 'END':
                break
            try:
                
                #if ftype == 'CASP' and row[:5] == 'MODEL'
                if ftype in ['casp','CASP']:
                    x,  y,  zero,  threshold,  val = split(row)
                elif ftype == 'eva':
                    contc,  x,  y,  ss1,  ss2,  zero,  threshold,  val = split(row)
                elif ftype == 'casp-like':
                    x, y, val = split(row)
                    threshold = 8.0#!
                x,  y = int(x),  int(y)
                #!!!
                x, y = x-1, y-1
    
                if T == None:
                    T = float(threshold)
                val = round(float(val), 5)
            except:
                raise 
            
            if contacts.has_key((x, y)):
                raise Exception
            
            if val > 0:
                contacts[(x, y)]=val
        
        else:
            #remarks
            tag = row[:6]
            
            if tag in ['PFRMAT',  'MODEL ']:
                pass
                
            elif tag in ['REMARK']:
                remark.append(row)
            
            elif tag in ['TARGET']:
                other['target'].append(row)
            elif tag in ['AUTHOR']:
                other['author'].append(row)
            elif tag in ['METHOD']:
                other['method'].append(row)
                
            elif tag in ['# job ']:
                remark.append('REMARK '+row)
        
            elif tag in ['# subm']:
                seq.append('SEQRES '+row[22:])
            
            elif row not in ['\n',  'END\n',  'END']:
                if ftype in ['casp', 'eva','CASP']:
                    if row[:6] != 'SEQRES':
                        seq.append('SEQRES '+row)
                    else:
                        seq.append(row)
                elif ftype == 'casp-like':
                    remark.append('REMARK '+row)
        
    return (contacts,  seq,  remark,  other,  T)
    
class GDModel(automodel):
    
        def __init2__(self,  *args,  **kwargs):
            
            self.cm = None
            automodel.__init__(self,  *args,  **kwargs)
    
        def read_gdrest(self,  cm_file):
            
            ss = self.get_ss()
            cm = read_contacts(cm_file,  ss)[0]
            
            return self.define_gdrest(cm)
        
        def read_ss_pred(self,  ss_file,  chain=None, ALTER=1):
            
            ss = read_ss_pred(ss_file,  chain, ALTER)
            
            return self.define_ss(ss)
        
        def define_ss(self,  ss):
            try:
                defined = (self.ss != None)
            except:
                defined = False
            self.ss = ss
            return not defined
        
        def define_gdrest(self,  cm):
            try:
                defined = (self.cm != None)
            except:
                defined = False
            self.cm = cm
            
            return not defined
            
        def get_gdrest(self):
            try:
                return self.cm
            except:
                return None
        
        def get_ss(self):
            try:
                return self.ss
            except:
                return None
        
        def special_restraints(self, aln):
            
            SHEET = __SHEET__
            
            self.special_restraints_contacts(aln)
            self.special_restraints_ss(aln,  SHEET)
            
            return True
        
        def special_restraints_contacts(self, aln):
            
            ss = self.get_ss()
            
            cm = self.get_gdrest()
            if cm == None:
                return None
            
            rsr = self.restraints
            at = self.atoms
            
            THRESHOLD = 8.0
            METRIC = self.__METRIC__###########'CA' bug!
            
            D_CUTOFF_MODELLER = 4 
            
            DIST = []
            STD = []
            f = open(FACTORING, 'r')
            row = f.readline()
            j = 0
            while j <= D_CUTOFF_MODELLER:
                i,  Dreal,  StDev = split(row, ',')
                Dreal = float(Dreal)
                StDev = float(StDev)
                DIST.append(Dreal)
                STD.append(StDev)
                row = f.readline()
                j = j + 1
            f.close()
            
            self.max_ca_ca_distance = DIST[D_CUTOFF_MODELLER]+ 3*STD[D_CUTOFF_MODELLER]
            ###
 
            log=open('rsr.log', 'aw')
            log.write('contact\n')
            
            N = len(cm[0])
            for i in range(N):
                for j in range(i+1, N):
                    d = cm[i][j]
                    if d > 0 and d <=D_CUTOFF_MODELLER:
                        Si = str(i+1)
                        Sj = str(j+1)
                        
                        D = None
                        STDEV = None
                        
                        if abs(j-i) == 1:
                            if ss[i] == 'S' and ss[j] == 'S' and (self.CONTC or (i-2 >= 0 and i+2 < N and ss[i+2] == 'S' and ss[i-1] =='S' and ss[i-2] == 'S')):
                                #intra-beta
                                D = 3.80428
                                STDEV = 1.0*0.280040
                            elif ss[i] == 'H' and ss[j] == 'H' and (self.CONTC or (i-4 >= 0 and i+4 < N and ss[i-1] == 'H' and ss[i+2] =='H' and ss[i-2] == 'H' and ss[i+3] == 'H' and ss[i-3] =='H' and ss[i+4] == 'H' and ss[i-4] =='H')):
                                #intra-alpha
                                D = 3.81647
                                STDEV = 1.0*0.349850
                            else:
                                D = DIST[0]
                                STDEV = 1.0*STD[0]
                        elif abs(j-i) == 2:
                            if ss[i] == 'S' and ss[j] == 'S' and (self.CONTC or (i-2 >=0 and ss[i+1] == 'S' and ss[i-1] == 'S' and ss[i-2] == 'S')):
                                #intra-beta
                                D = 6.65918
                                STDEV = 1.0*0.301882
                            elif ss[i] == 'H' and ss[j] == 'H' and (self.CONTC or (i-4 >= 0 and i+4 < N and ss[i+1] == 'H' and ss[i-1] =='H' and ss[i-2] == 'H' and ss[i+3] == 'H' and ss[i-3] =='H' and ss[i+4] == 'H' and ss[i-4] =='H')):
                                #intra-alpha
                                D = 5.50295
                                STDEV = 1.0*0.516202
                        elif abs(j-i) == 3:
                            if ss[i] == 'H' and ss[j] == 'H' and (self.CONTC or (i-4 >= 0 and i+4 < N and ss[i+1] == 'H' and ss[i-1] =='H' and ss[i+2] == 'H' and ss[i-2] == 'H' and ss[i-3] =='H' and ss[i+4] == 'H' and ss[i-4] =='H')):
                                #intra-alpha
                                D = 5.33140
                                STDEV = 1.0*0.925609
                        elif abs(j-i) >= 4:
                            if abs(j-i) == 4 and ss[i] == 'H' and ss[j] == 'H' and (self.CONTC or (i-4 >= 0 and ss[i+1] == 'H' and ss[i-1] =='H' and ss[i+2] == 'H' and ss[i-2] == 'H' and ss[i+3] =='H' and ss[i-3] == 'H' and ss[i-4] =='H')):
                                #intra-alpha
                                D = 6.41609
                                STDEV = 1.0*1.040134
                            elif self.CONTC:
                                if d == 1:
                                    if ss[i] == 'S' and ss[j] == 'S':    
                                        D = 5.97686
                                        STDEV = 1.0*0.94402
                                    elif (ss[i] == 'S' and ss[j] == 'H') or (ss[i] == 'H' and ss[j] == 'S'):    
                                        D = 6.86291
                                        STDEV = 1.0*0.87823
                                    elif (ss[i] == 'S' and ss[j] not in 'HS') and (ss[i] not in 'HS' and ss[j] == 'S'):    
                                        D = 6.47548
                                        STDEV = 1.0*0.96044
                                    elif ss[i] == 'H' and ss[j] == 'H': 
                                        D = 6.06732
                                        STDEV = 1.0*0.90023
                                    elif (ss[i] == 'H' and ss[j] not in 'HS') and (ss[i] not in 'HS' and ss[j] == 'H'):    
                                        D = 6.59954
                                        STDEV = 1.0*0.98310
                                    else:
                                        ###STDEV = 2.5*0.91
                                        D = 6.38047
                                        STDEV = 1.0*1.05972
                                else:
                                    ###STDEV = 2.5*STD[d]
                                    D = DIST[d]
                                    STDEV = 1.0*STD[d]
                        
                        try:
                            a1 = at[METRIC+':'+Si]
                        except KeyError:
                            a1 = at['CA:'+Si]
                        try:
                            a2 = at[METRIC+':'+Sj]
                        except KeyError:
                            a2 = at['CA:'+Sj]
                        
                        if D != None:
                            rsr.add(forms.upper_bound(group=physical.xy_distance,
                                       feature=features.distance(a1, a2), mean=D, stdev=STDEV))
                            log.write(METRIC+':'+Si+METRIC+':'+Sj+':'+str(D)+','+str(STDEV)+'\n')
            
            log.close()
            
            return self.max_ca_ca_distance
        
        def special_restraints_ss(self, aln,  SHEET):
            
            ss = self.get_ss()
            if ss == None:
                return None
            
            rsr = self.restraints
            res = self.residues
            
            log=open('rsr.log', 'aw')
            log.write('ss\n')
 
            i = 0
            state = '-'
            while i < len(res):
                
                try:
                    if state == '-' and ss[i] == '-':
                        i = i + 1
                    elif state == '-':
                        state = ss[i]
                        j = i
                        k = None
                        i  = i + 1
                    elif state != '-':
                        if ss[i] == state:
                            i = i + 1
                        elif ss[i] != state or i == len(ss) -1:
                            k = i - 1
                            J = j
                            K = k
                            if state == 'H':
                                rsr.add(secondary_structure.alpha(self.residue_range(J, K)))
                                log.write(str(J+1)+':'+str(K+1)+':'+state+'\n')
                            elif state == 'S' and SHEET:
                                rsr.add(secondary_structure.strand(self.residue_range(J, K)))
                                log.write(str(J+1)+':'+str(K+1)+':'+state+'\n')
                    
                            if ss[i] not in '-T':
                                j = i
                                k = None
                            state = ss[i]
                            i = i + 1
                except:
                    print state, ss, len(ss), i
                    raise            
                
            log.close()
            
            return True

def make_pir(pdb_file,  dir='.', oname=None,  chain=None):

    
    #####################
    ###change
    #code = pdb_file[:5]
    code = pdb_file[:-4]
    #####################
    
    if oname == None:
        #oname = upper(code)+'.seg'
        oname = upper(pdb_file[:-4])+'.seg'
    
    parser = BrutePDBParser()
    struct = parser.get_structure(DIR+lower(pdb_file[:-4])+'.pdb')
    model = struct[0]
    if chain == None:
        chains = model.child_list
    else:
        try:
            chains = [model[chain]]
        except KeyError:
            chains = [model[' ']]
    
    seq = ''
    for chain in chains:
        old_id = None
        for res in chain:
            if res.get_id()[0] != ' ':###fix
                continue
            if old_id == None:
                old_id = res.get_id()[1]
            id = res.get_id()[1]
            g = '-'*(id-old_id-1)
            old_id = id
            aaa = res.get_resname()
            a = parser.translator.get1original(aaa)
            seq = seq + g + a
    
    UNK1 = parser.translator.unknown1
    seq1 = seq#replace(seq, UNK1, '-')
    seq2 = seq#replace(seq, UNK1, '')
    seq = seq2
    
    rowdata = []
    N = len(seq)
    SN = str(N)+(5-len(str(N)))*' '
    
    TEMPLATE = upper(code)
    TARGET = lower(code)
    #TARGET = code[:-1]+lower(code[-1])
 
    line = '>P1;'+TEMPLATE+ '\n'
    rowdata.append(line)
    line = 'sequence:'+TEMPLATE+':1    : :'+SN+': :'+TEMPLATE+':Q:.:.\n'#2.00:-1.00\n'
    rowdata.append(line)
    line = seq+ '*\n'
    rowdata.append(line)
    line = '>P1;'+TARGET+'\n'
    rowdata.append(line)
    #line = 'structureX:'+lower(code)+':FIRST:@:1:::::\n'
    #line = 'structureX:'+TARGET+':FIRST:@:1:@:'+TEMPLATE+':::\n'
    line = 'structureX:'+TARGET+':1    : :'+SN+': :'+TEMPLATE+':Q::\n'#5.00:1.0\n'#res, rfactor
    rowdata.append(line)
    line = seq + '*\n'
    rowdata.append(line)
    
    f = open(oname, 'w')
    f.writelines(rowdata)
    f.close()
    
    return seq

def MD_refine(atmsel, actions):
    return refine.refine(atmsel, actions, cap=0.39, timestep=3.0,
       equil_its=2000, equil_equil=50,
       equil_temps=(150.0, 250.0, 400.0, 700.0, 1000.0, 1500.0),
       sampl_its=20000, sampl_equil=500,
       sampl_temps=(1500.0, 1000.0, 800.0, 600.0, 500.0, 400.0, 300.0))

def slow_large(atmsel, actions):
    return refine.refine(atmsel, actions, cap=0.39, timestep=10.0,
       equil_its=200, equil_equil=20,
       equil_temps=(150.0, 250.0, 400.0, 700.0, 1000.0, 1500.0),
       sampl_its=2000, sampl_equil=200,
       sampl_temps=(1500.0, 1000.0, 800.0, 600.0, 500.0, 400.0, 300.0))

def my_dihedrals(atmsel):
    """Randomize dihedrals"""
    
    from modeller.selection import selection
    
    mdl = atmsel.get_model()
    aln = alignment(mdl.env, file=mdl.alnfile,
                    align_codes=mdl.knowns+[mdl.sequence])
    # Just in case, generate topology again (ROTATE needs bonds)
    # (could replace with GENERATE_TOPOLOGY if no special patches)
    mdl.create_topology(aln)

    # Optimize all dihedral angles:
    atmsel.rotate_dihedrals(change='RANDOMIZE', deviation=mdl.deviation,
                            dihedrals=('phi', 'psi', 'omega', 'chi1', 'chi2',
                                       'chi3', 'chi4'))

def main(argv):
    
    if len(argv) >= 3:
        binstr=argv[2]
        CONTC=int(binstr[0])
        SS=int(binstr[1])
    elif len(argv) == 2:
        CONTC=False
        SS=False
    else:
        print "usage: gdrest target [Binstr_ContcBinstr_Ss metric ALTER]"
        from sys import exit
        exit(1)
    if len(argv) >= 4:
        METRIC = argv[3]
    if len(argv) == 5:
        ALTER = argv[4]
        if ALTER in '01':
            ALTER = int(ALTER)
        else:
            ALTER = None
    else:
        ALTER = None
    
    TARGET= argv[1]
    SOURCE = TARGET

    from time import sleep
    sleep(10)   
 
    if ALTER != None:
        if ALTER == False:
            filename = PATH+SOURCE+METRIC+'.25.lfactor.mdsx.pdb'
            MODE = 'B'
            ofn = PATH+SOURCE+METRIC+'.25.lfactor.mds.pdb'
        elif ALTER == True:
            filename = PATH+SOURCE+METRIC+'.25.lfactor.mdsx.a.pdb'
            ofn  = PATH+SOURCE+METRIC+'.25.lfactor.mds.a.pdb'
            MODE = 'A'
        
        ff = open(ofn, 'r')
        gg = open(filename, 'w')
        row = ff.readline()
        while row != '':
            if row[:4] != 'ATOM':
                row3 = row
            else:
                row2 = replace(row, '\x01', '')
                row3 = row2[:11]+' '+row2[11:]
            gg.write(row3)
            row = ff.readline()
        ff.close()
        gg.close()
        
    else:
        filename = '/home/michalp/gd_server/refiner/remodel/'+upper(SOURCE)+'.mr.pdb'
        MODE = None
        system('mv '+upper(SOURCE)+'* /home/michalp/gd_server/modeller/INI/'+SOURCE)	
    
    if MODE != None:
        atm_fn = lower(SOURCE)+lower(MODE[-1])
    else:
        atm_fn = lower(SOURCE[:-1])+lower(SOURCE[-1])
    #system('cp '+filename+' '+DIR+lower(SOURCE[:-1])+lower(SOURCE[-1])+'.pdb')
    system('cp '+filename+' '+DIR+atm_fn+'.pdb')
    
    chain = 'A'
    
    #if MODE == 'B':
    #seq = make_pir(TARGET[:-1]+lower(TARGET[-1])+'.pdb', chain=chain)
    #else:
    #    system('cp /home/michalp/gd_server/modeller/INI/'+upper(TARGET)+'/B/'+ upper(TARGET) + '.seg /home/michalp/gd_server/')seq = make_pir(TARGET+lower(TM)+'.pdb', chain=chain)
    if MODE != None:
        TM = MODE
    else:
        TM = ''
    TTM = TARGET + TM
    seq = make_pir(TTM[:-1]+lower(TTM[-1])+'.pdb', chain=chain)
    gapped = '-' in seq
    if gapped:
        raise "gapped"
        
    aln_f = upper(TARGET)+TM+'.seg'
    know_mdl = lower(TARGET)+lower(TM)
    know_seq = upper(TARGET)+upper(TM)
    
    log.verbose()
    env = environ()
    env.io.atom_files_directory = ['.', DIR]
    
    if CONTC:
        ###env.libs.topology.clear()
        env.libs.topology.read(file='$(LIB)/top_ca.lib')
    else:
        ###env.libs.topology.clear()
        env.libs.topology.read(file='$(LIB)/top.lib')
        ###env.libs.topology.read(file='$(LIB)/top_heav.lib')
        ###env.libs.topology.make(submodel=3)
    
    a = GDModel(env,
                  alnfile  = aln_f,
                  knowns   = (know_mdl),
                  sequence = know_seq, 
                  inifile  = know_mdl
                )
    
    a.__METRIC__ = METRIC
    
    pdm_file = PATH+SOURCE+METRIC+'.25.lfactor.pdm.txt' 
    pdb_file = SOURCE 
    
    a.CONTC = CONTC
    if SS:
        a.read_ss_pred(pdb_file,  chain, ALTER)
    a.read_gdrest(pdm_file)
    
    #optimisation
    a.rand_method = my_dihedrals###default=xyz
    a.deviation=2.0###default=4
    # Very thorough VTFM optimization:
    a.library_schedule = autosched.slow###default=autosched.normal
    a.max_var_iterations = 22000###default=200
    # Thorough MD optimization:
    a.md_level = MD_refine###slow_large###default=very_fast
    # Repeat the whole cycle 2 times and do not stop unless obj.func. > 1E6
    a.repeat_optimization = 2###default=1
    a.max_molpdf = 1e6###default=1e7
        
    a.auto_align()# get an automatic alignment
    
    a.make()# do homology modeling
    
    if ALTER != None:
        ex = system('ls /home/michalp/gd_server/modeller/INI/'+ SOURCE+' 1>/dev/null 2>/dev/null')
        if ex > 0:
            system('mkdir /home/michalp/gd_server/modeller/INI/'+ SOURCE)
        system('mkdir /home/michalp/gd_server/modeller/INI/'+ SOURCE+'/'+MODE+'/')
        #system('mv '+upper(SOURCE)+'* /home/michalp/gd_server/modeller/INI/'+SOURCE+'/'+MODE+'/')	
        system('mv '+upper(SOURCE)+MODE+'* /home/michalp/gd_server/modeller/INI/'+SOURCE+'/'+MODE+'/')	
    
    if ALTER == None:
        #server job finish
        rowdata = open(upper(SOURCE)+'.B99990001.pdb','r').readlines()
        out = open(SS_PRED_DIR+SOURCE+'.confuzz.3d.pdb','w')
        out.write('TARGET '+SOURCE+'\n')
        out.write('METHOD 2D: input by the user\n')
        out.write('METHOD 3D: graph distance 25 psi CA\n')

        for row in rowdata:
                if row[:4] in ['ATOM','TER ','END ']:
                        out.write(row)
        out.close()
    
    return True

if __name__ == '__main__':
    
    from sys import argv
    main(argv)
