#!/usr/bin/python

from run_confuzz import *

if __name__ == '__main__':

    MODEL_DIR = '/home/michalp/gd_server/INI/'
    REFDIR = '/home/michalp/gd_server/refiner/'

    _MODES_ = 'AB'
    
    from sys import argv
    from string import upper,  lower,  replace
    from os import system
     
    if len(argv) < 2:
        print "usage refiner target pdb_dir [TOLERANCE]"
        from sys import exit
        exit(1)
    
    if len(argv) == 2:
        PDBDIR = MODEL_DIR
    else:
        PDBDIR  = argv[2]
    
    if len(argv) > 3:
        TOLERANCE = int(argv[3])
    else:
        TOLERANCE  = True
    
    TARGET = argv[1]
    PDB = upper(TARGET) 
    pdb = TARGET
     
    configdata = open(REFDIR+'config.dat', 'r').readlines()
     
    command_list = []
    cores = 2
     
    while pdb != '':
        for MODE in _MODES_:
            if len(_MODES_) == 1:
                MODE = 'B'
            cfg = []
            for c in configdata:
                if 'MODEL.MODE' in c:
                    #d = replace(c, 'MODEL', PDBDIR+PDB+'/'+MODE+'/'+PDB)
                    d = replace(c, 'MODEL', PDBDIR+PDB+'/'+MODE+'/'+PDB+MODE)
                    d = replace(d, 'MODE', 'B')
                elif 'MODELMODE' in c:
                    d = replace(c, 'MODEL', PDB)
                    d = replace(d, 'MODE', MODE)
                elif 'MODEL' in c:
                    d = replace(c, 'MODEL', pdb)
                else:
                    d = c
                cfg.append(d)
            
            #cfg_name = REFDIR+'config/'+pdb+'.config.dat'
            cfg_name = REFDIR+'config/'+pdb+MODE+'.config.dat'
            mut_name = REFDIR+'ss/'+pdb+'.seq.mut'
            symul_name = REFDIR+'symul_20r_1.dat'
           
            #max_distance_constr increased from 50 K to 150 K 
            if TOLERANCE:
                #bin = REFDIR+'refin8.31_rT05_MDC/refin8.31_r_B0'
                bin = REFDIR+'refin8.31_rT05_MDC_B/refin8.31_r_B0'
                print "tolerance 0.5 and burial selected"
            else:
                bin = REFDIR+'refin8.31_r_MDS/refin8.31_r_B0'
                print "tolerance 0.15 selected"
                
            f=open(cfg_name, 'w')
            f.writelines(cfg)
            f.close()
            
            cmd = 'time '+bin+ ' '+cfg_name+' '+symul_name+' '+mut_name
            bin_dir = '/home/michalp/gd_server/refiner/'
            
            ###system (cmd)
            command_list.append((cmd,  bin_dir))
            print cmd,  "coded."
        
        print "Warning: parallel logging enabled"
        run_parallel(command_list,  cores)

   	pdb = ''

    print "Parallel logging disabled"
    system(REFDIR+'rebuild_MODE_trim.py ' + PDB) 
