#!/usr/bin/python2.6

import string
import os

import Queue, thread, subprocess

def nice(command,  n=-5):

    #nice_command = 'nice -n '+str(n)+' '+command
    
    #return nice_command

    #disable nice

    return command

def time(command):
    
    time_command = 'time '+command
    
    return time_command

def run_command(command):
     
    nice_command = nice(command)
    
    try:
        p = subproces.popen(nice_command )
        p.wait()
        return None
    except:
        return 1

def run_parallel(command_list,  cores=7):
    
    results= Queue.Queue()
    process_count= 0
    cnt = 0
    
    while len(command_list) > 0:
        
        while process_count < cores and len(command_list) > 0:
            command,  bin_dir = command_list.pop()
            if bin_dir != None:
                os.system('cd '+bin_dir)
            process_count,  cnt = run_thread(command,  results,  process_count,  cnt)
        
        print str(process_count),  "commands in run"
    
        while process_count > 0:
            
            description, rc= results.get()
            print "job", description, "ended with rc =", rc
            
            process_count = process_count - 1
            if len(command_list) > 0:
                command,  bin_dir = command_list.pop()
                if bin_dir != None:
                    os.system('cd '+bin_dir)
                process_count,  cnt = run_thread(command,  results,  process_count,  cnt)
            
            print str(process_count),  "commands in run"
        
        return None

def process_waiter(popen, description, que):
    
    try: 
        popen.wait()
    finally: 
        que.put( (description, popen.returncode) )
    
    return None

def run_thread(command,  results,  process_count,  counter):
    
    nice_command = nice(command)
    
    proc= subprocess.Popen( nice_command, shell=True )
    thread.start_new_thread(process_waiter,(proc, str(counter)+' ('+str(process_count)+") finished", results))
    
    return process_count + 1,  counter + 1

def main(argv):
    
    FASDIR='/home/michalp/server/fasta/'
    methods = ['betapro', 'nncon', 'svmseq', 'svmcon','possum']#last two methods altered! possum moved from middle to an end
    
    if len(argv) < 4 or argv[1][-4:] != '.fas':
        print "usage: run_confuzz fasta.fas bbbbb cores [out_name]"
        s = '[methods:'
        for m in methods:
            s = s + ' '+m
        s = s + ']'
        print s
        from sys import exit
        exit(2)
    
    fas_file = argv[1]
    #fasta = FASDIR+fas_file
    
    run_mask = argv[2]
    
    try:
        cores = int(argv[3])
        if cores > 5:
            raise Exception
    except:
        print "maximum cores 5 overriden"
    
    NAME = fas_file[:-4]
    if len(argv) > 4:
        name = argv[4]
    else:
        name = NAME
    
    OUT_MAPS=[]
    
    commands = {
                            'betapro': (None,None,'/home/cmpred/betapro-1.0/bin/predict_beta_fasta.sh','FASTA','OUT',  None, 'OUT'), 
                            'nncon': ('/home/michalp/methods/nncon/nncon1.0/_fasta/',None,'/home/michalp/methods/nncon/nncon1.0/bin/predict_ss_sa_cm.sh', 'FASTA', '/home/michalp/server/PRED/',  None, '/home/michalp/server/PRED/NAME/NAME_fas.cm8a'), 
                            'possum':(None,None,'/home/michalp/methods/possum/possum.sh', 'FASTA', None, '.cm.txt', 'NAME.cm.txt'), 
                            'svmcon': (None,None,'/home/michalp/methods/svmcon/svmcon1.0/bin/predict_map.sh', 'FASTA', 'OUT',  None, 'OUT'), 
                            'svmseq': ('/home/michalp/methods/svmseq/SVMSEQ_source/example/NAME/','seq.txt','/home/michalp/methods/svmseq/SVMSEQ_source/SVMSEQ/SVMSEQ.pl',  'NAME', None, '/home/michalp/methods/svmseq/SVMSEQ_source/example/NAME/svmseq.dat', '/home/michalp/methods/svmseq/SVMSEQ_source/example/NAME/svmseq.dat')
                            }
    
    command_list = []
    
    for i in range(5):
        if run_mask[i] == '0':
            continue
    
      	fasta = FASDIR+fas_file#!!! bugfix
    
        method = methods[i]
        
        in_dir,  in_format,  binary,  in_file,  out,  out_location,  out_filename = commands[method]
        
        i = string.rfind(binary, '/')
        bin_dir = binary[:i+1]
        
        if out_filename == 'OUT':
            out_filename  = NAME+'.'+method+'.cm.txt'
        else:    
            out_filename = string.replace(out_filename, 'NAME', NAME)
        
        if out_location != None and 'NAME' in out_location:
            out_location = string.replace(out_location, 'NAME', NAME)
        
        if in_dir != None:
            if 'NAME' in in_dir:
                in_dir = string.replace(in_dir, 'NAME', NAME)
            #rude!
            try:
                os.mkdir(in_dir)
            except:
                pass
            if in_format != None:
                #svmseq
                old_fasta = fasta
                new_fasta = in_dir+in_format
                #os.system('sudo tail -n 1 '+old_fasta+' > '+new_fasta)
		#ConFuzz fix - no sudo
		os.system('tail -n 1 '+old_fasta+' > '+new_fasta)
                fasta = new_fasta
            else:
                #os.system('sudo cp '+fasta+' '+in_dir)
		#ConFuzz fix - no sudo
		os.system('cp '+fasta+' '+in_dir)
        
        if in_file == 'NAME':
            #svmseq
            fasta = NAME
	else:
	    #svmcon + others? fix
	    fasta = FASDIR+fas_file
        
        if out == 'OUT':
            out_file = NAME+'.'+method+'.cm.txt'
        elif out != None:
            #nncon
            out_dir = out+NAME#+'_fas.cm8a'
            try:
                os.mkdir(out_dir)
            except:
                pass
            out_file = out+NAME#+'_fas.cm8a'
        elif out == None:
            #possum
            out_file = ''
        
        command = binary+' '+fasta+ ' '+out_file
        
        if out_location == None:
            out_location = out_file
        elif out_location == '.cm.txt':
            #possum
            out_location = NAME+'.cm.txt'
        
        #if string.find(out_location, '/') == -1:
        #    out_location = bin_dir + out_location
        
        command_list.append((command, bin_dir))
        OUT_MAPS.append(out_filename)
        print command,  "coded. Expect output in ", out_filename
    
    print "running predictions, please be patient..."
    run_parallel(command_list,  cores)
    
    #tidy
    
    print "Great success!"
    
    return OUT_MAPS

if __name__ == '__main__':
    
    from sys import argv
    
    OUT = main(argv)
    
    from sys import exit
    
    exit(OUT)
    
